;;; lisp file for xyzzy ver0.2.2.233
;;; 팩 outline.l remodel ver0.1.0.8 // crayonzen [2006-11-08]12:25:40(+0900)

#|
.xyzzy ܂ siteinit.l 
(require "outline")
ƏށB
isiteinit.l ̓t@CoCgRpC( M-x: byte-compile-file )āA
_vt@Cixyzzy.w98  xyzzy.w2k Ȃǁj폜xyzzyċNj

outline ;;I͈͂̕ŁBƂ̓L[͑҂BF"^"is"^"""AEgCj
outline-text ;;eLXgpBL̐ݒ̃LɂB
outline-lisp ;;LisppBL̐ݒ̃LɂB
outline-paragraph ;;ipi󔒍sŁjB
outline-jump ;;Enter@F10@Dwon@Up@̃L[ŃWviCԍɂ̂łBjB
outline-margin ;;ꎞIɃAEgC̃EBhE̕ύXB
outline-mode ;;AEgC[hɂB
|#
;;;L[蓖Ă̗
;;;(global-set-key #\C-F10 'outline)

(provide "outline")

(in-package "editor")

(export '(outline
	  outline-text
	  outline-lisp
	  outline-paragraph
	  outline-jump
	  outline-margin
	  outline-mouse-left-up
	  outline-mode

	  *outline-pattern*
	  *outline-mode-hook*

	  *outline-menus*))

(defvar *outline-mode-hook* nil)

(defvar *outline-pattern* "^[E]")

;;;eLXg
(defvar *outline-pattern-text* "^[yE]")

;;;Lisp
(defvar *outline-pattern-lisp* "^\\((provide\\|(export\\|(def\\)")
;(defvar *outline-pattern-lisp* "^\\(;;;\\| *\"\\|(provide\\|(def\\)")

;;;i@s󔒂ɂ
(defvar *outline-pattern-paragraph* "^\\( \\|@\\|\t\\)*?\$")

(defvar *outline-header* "Outline-")
(defvar *outline-margin* 30)

(defvar *outline-mode-map* nil)
(unless *outline-mode-map*
  (setq *outline-mode-map* (make-sparse-keymap))
  (define-key *outline-mode-map* #\F10 'outline-jump)
  (define-key *outline-mode-map* #\RET 'outline-jump)
  (define-key *outline-mode-map* #\Down 'outline-jump-down)
  (define-key *outline-mode-map* #\Up 'outline-jump-up)
  (define-key *outline-mode-map* #\LBtnUp 'outline-mouse-left-up)
  )

;;;I𕶎B܂͓͑҂B
(defun outline ()
  (interactive "*")
  (cond ((pre-selection-p)
	 ;;selection
	 (let ((strpattern (buffer-substring (setq from (selection-mark))
					     (setq to (selection-point)))))
	   (setq strpattern (regexp-quote strpattern))
	   (save-excursion
	     (if (> from to)
		 (rotatef from to))
	     (goto-char from)
	     (if (bolp)
		 (setq strpattern (concat "^" strpattern))
	       (progn
		 (goto-char to)
		 (if (eolp)
		     (setq strpattern (concat strpattern "$")))
		 )
	       )
	     )
	   (outline-make strpattern))
	 )
	(t
	 ;;input
	 (let ((strpattern (read-string "outline(regexp): " :default *outline-pattern*)))
	   (unless (string= strpattern "")
	     (outline-make strpattern)))
	 )
	)
  )

(defun outline-text ()
  (interactive "*")
  (outline-make *outline-pattern-text*)
  )

(defun outline-lisp ()
  (interactive "*")
  (outline-make *outline-pattern-lisp*)
  )

(defun outline-paragraph ()
  (interactive)
  (outline-make *outline-pattern-paragraph* "paragraph")
  )

;;;Outlinẽobt@̖O
(defun outline-buffer-name (buf)
  (if (bufferp buf)
      (setq buf (buffer-name buf)))
  (concat *outline-header* buf))

;;;Outlinẽobt@ďo
(defun outline-make (&optional (pattern) (type nil))
  (interactive)
  (long-operation
    (let ((sb (selected-buffer))
	  (sbwin (selected-window))
	  ob obname)
      (setq obname (outline-buffer-name sb))
      (save-excursion

	;;̃EBhEĂEBhE𕪊
	(if (setq ob (find-buffer obname))
	    (progn
	      (unless (setq obwin (get-buffer-window ob))
		(delete-other-windows)
		(outline-split-window)
		(setq obwin (selected-window))
		))
	  (progn
	    (delete-other-windows)
	    (setq ob (create-new-buffer obname))
	    (outline-split-window)
	    (setq obwin (selected-window))))

	;;̃obt@ĂEChEĂȂΕ
	;;̃obt@Ȃ΃obt@ăEBhE
	;;	(if (setq ob (find-buffer obname))
	;;	    (progn
	;;	      (unless (setq obwin (get-buffer-window ob))
	;;		(outline-split-window)
	;;		(setq obwin (selected-window))
	;;		(other-window)
	;;		))
	;;	  (progn
	;;	    (setq ob (create-new-buffer obname))
	;;	    (outline-split-window)
	;;	    (setq obwin (selected-window))))

	;;obt@eSNA
	(set-buffer ob)
	(delete-region (point-min) (point-max))
	;;óFʏpƒip̃^Cvɕ
	(set-buffer sb)
	(with-output-to-buffer (obname nil)
	  (goto-char (point-min))
	  (if (equal type "paragraph")
	      (outline-output-paragraph pattern)
	    (outline-output pattern)))
	;;Outlinep̃[hZbg
	(set-buffer ob)
	(outline-mode)
	)
      ;;ړ
      (set-window obwin)
      (set-buffer ob)
      (message "completed. JUMP Key: Enter or F10")
      ))
  )

;;;EBhE
;
;;(defun outline-split-window ()
;;  (let ()
;;    (split-window (- (floor (window-height) 2) 2))
;;    (selected-buffer))
;;  )
;;
;;
;;(defun outline-split-window ()
;;  (let ()
;;    (if (>= (window-height) (+ *outline-margin* *outline-margin*))
;;	(split-window *outline-margin* nil)
;;	(split-window (truncate (window-height) 2) nil))
;;    (selected-buffer))
;;  )

;c
(defun outline-split-window ()
  (let ()
    (split-window *outline-margin* t)
    (selected-buffer))
  )
;;
;;(defun outline-split-window ()
;;  (let ()
;;    (if (>= (window-width) (+ *outline-margin* *outline-margin*))
;;	(split-window *outline-margin* t)
;;      (split-window (truncate (window-width) 2) t))
;;    (selected-buffer))
;;  )

;;;óFʏp
(defun outline-output (pattern)
  (while (scan-buffer pattern :regexp t)
    (format t "~D:~A~%" (current-line-number) (buffer-substring (progn (goto-bol) (point))
								(progn (goto-eol) (point))))
    (or (forward-char 1)
	(return)))
  )

;;;óGip
(defun outline-output-paragraph (pattern)
  (format t "~D:~A~%" (current-line-number) (buffer-substring (progn (goto-bol) (point))
							      (progn (goto-eol) (point))))
  (while (scan-buffer pattern :regexp t)
    (unless (forward-line) (return))
    (unless (eql "^\$"
		 (setq linestring (buffer-substring(progn (goto-bol) (point))
						   (progn (goto-eol) (point)))))
      (format t "~D:~A~%" (current-line-number) linestring)
      )
    (forward-line -1) (goto-eol)
    (or (forward-char 1)
	(return)))
  )

;;;{̃Wv
(defun outline-jump-down ()
  (interactive)
  (if (next-virtual-line)
      (outline-jump)))

(defun outline-jump-up ()
  (interactive)
  (if (previous-virtual-line)
      (outline-jump)))

(defun outline-jump ()
  (interactive)
  (let ((sw (selected-window))
	(bname (substring (buffer-name (selected-buffer)) (length *outline-header*) nil))
	(stringline nil))
    (save-excursion
      (setq stringline (buffer-substring (progn (goto-bol) (point))
					 (progn (goto-eol) (point))))
      (setq mp (string-match ":" stringline))
      (if (null mp)
	  (return-from outline-jump)
	(progn
	  (setq headlinenumber (parse-integer (substring stringline 0 mp) :junk-allowed t))
	  (if (null headlinenumber)
	      (return-from outline-jump)
	    (progn
	      (setq headlinestring (substring stringline (incf mp) nil))

	      (cond ((= (count-windows 'foo) 1)
		     (outline-split-window)
		     (other-window)
		     (set-buffer bname))
		    (t (pop-to-buffer bname)))

	      ;(goto-char (point-min))
	      ;(scan-buffer headlinestring)
	      (goto-line headlinenumber)
	      (recenter 0)
	      (set-window sw)))))
      )
    (reverse-region-mark-line)
    )
  )

(defun reverse-region-mark-line ()
  (let ((curpoint (point)))
    (setq from (progn (goto-eol) (point)))
    (setq to (progn (goto-bol) (point)))
    (reverse-region from to t)
    (goto-char curpoint))
  )

;;;̐ݒύX
(defun outline-margin (n)
  (interactive "nmargin: " :default *outline-margin*)
  (setq *outline-margin* n))

(defun outline-mouse-left-up ()
  (interactive)
  (continue-pre-selection)
  (selection-leave)
  (if (and (eq buffer-mode 'outline-mode)
	   (= *last-mouse-click-count* 2))	  
      (outline-jump))
  )

;;;[hݒ
(defun outline-mode ()
  (interactive)
  (kill-all-local-variables)
  ;;(setq buffer-read-only t)
  (set-buffer-fold-width nil)
  (set-buffer-modified-p nil)
  (setq buffer-mode 'outline-mode)
  (setq mode-name "Outline")
  (use-keymap *outline-mode-map*)
  (run-hooks '*outline-mode-hook*))

;;;;;;;;;;;;;;;;menu
(defvar *outline-menus* nil)

(defun init-outline-popup-menu ()
  (or *outline-menus*
      (setq *outline-menus* (create-popup-menu)))

  (setq *outline-menus*
	(define-popup-menu
	  (:item nil"Í͈issʂ܂j܂͓(&S)"
	   'outline)
	  (:item nil (concat "eLXg" *outline-pattern-text* "(&T)")
	   'outline-text)
	  (:item nil "Lisp(&L)"
	   'outline-lisp)
	  (:item nil "ii󔒍sɂj(&P)"
	   'outline-paragraph)
	  )))

;;;;;;;;;;;;;;;; }j[U@insert menu tools c[
(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (when (and *app-menu*
			 (setq menu (get-menu *app-menu* 'ed::tools)))
		(init-outline-popup-menu)
		(setq ip -1)
		(while (get-menu menu (incf ip) t))

		(insert-menu-separator menu ip 'outline-menu-sep1)
		(insert-popup-menu menu (incf ip) *outline-menus* "AEgC(&L)")
		)
	      )
	  )
