;; lisp file for xyzzy ver0.2.2.233
;;;Jamming-search.l
;;;Jamming̎g悤ɂ

;(load-library "Jamming-search")

(provide "Jamming-search")

(in-package "editor")

(export '(Jamming-app
	  Jamming-search-normal-all-selection
	  Jamming-search-complete-all-selection
	  Jamming-search-western-all-selection
	  
	  Jamming-search-normal-selection
	  Jamming-search-complete-selection
	  Jamming-search-western-selection

	  Jamming-search-kanjigen-selection
	  Jamming-search-Koujien-selection
	  Jamming-search-Daijirin-selection
	  Jamming-search-Chujiten-selection
	  Jamming-search-pc_wdic-selection

	  get-current-word-or-selection
	  backward-word-stop
	  ;goto-word-head
	  ;init-Jamming-menu
	  ))

;;;;;;;;;;;;;;;;Jamming
(defun Jamming-app ()
  (interactive)
  (launch-application "C:/Program Files/Jamming/Jamming.exe"))

;;;;;;;;;;;;;;;;R}hC
;;-n"name" 	F@EZbg
;;-m"method" 	F@@B(method "␳")
;;-w"word"	F@word 

;;-p	F@VKEBhE̍쐬Ȃ
;;-f	F@ɃtHAOEhɏo
;;-s	F@Sv
;;-e	F@[hŌinꂽBꂾƂ݂ȂČj

;;-d"path" 	F@ݒfBNgBݒfBNgʂɂ
;;-#012	F@EBhEԍB JammingNBO͑SāiftHg͂OjA1ԏオԍPB
;;-i0 ` -i5   F ͗̎wiftHgF-i0jBȂǂœ͗


;;;;;;;;;;;;;;;;ׂĂ̎
;;ʏ팟
(defun Jamming-search-normal-all-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A~A" "C:/Program Files/Jamming/Jamming.exe -p -f -#1 -n\"ׂĂ̎\" -w " word))))

;;Sv
(defun Jamming-search-complete-all-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A~A" "C:/Program Files/Jamming/Jamming.exe -p -f -#1 -n\"ׂĂ̎\" -s -w " word))))

;;[hŌ
(defun Jamming-search-western-all-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A~A" "C:/Program Files/Jamming/Jamming.exe -p -f -#1 -n\"ׂĂ̎\" -e -w " word))))


;;;;;;;;;;;;;;;;ʏ
;;ʏ팟
(defun Jamming-search-normal-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A~A" "C:/Program Files/Jamming/Jamming.exe -p -f -#1 -n\"ʏ\" -w " word))))

;;Sv
(defun Jamming-search-complete-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A~A" "C:/Program Files/Jamming/Jamming.exe -p -f -#1 -n\"ʏ\" -s -w " word))))

;;[hŌ
(defun Jamming-search-western-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A~A" "C:/Program Files/Jamming/Jamming.exe -p -f -#1 -n\"ʏ\" -e -w " word))))

;;;;;;;;;;;;;;;;
(defun Jamming-search-kanjigen-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A -p -f -#1 -n\"\" -w ~A" "C:/Program Files/Jamming/Jamming.exe" word)
     )))

(defun Jamming-search-Koujien-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A -p -f -#1 -n\"L@l\" -w ~A" "C:/Program Files/Jamming/Jamming.exe" word)
     )))

(defun Jamming-search-Daijirin-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A -p -f -#1 -n\"Oȓu厫сv\" -w ~A" "C:/Program Files/Jamming/Jamming.exe" word)
     )))

(defun Jamming-search-Chujiten-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A -p -f -#1 -n\"Ё@VpaEapT\" -w ~A" "C:/Program Files/Jamming/Jamming.exe" word)
     )))

(defun Jamming-search-pc_wdic-selection ()
  (interactive)
  (let ((word (get-current-word-or-selection)))
    (launch-application
     (format nil "~A -p -f -#1 -n\"ʐMp̊bm\" -w ~A" "C:/Program Files/Jamming/Jamming.exe" word)
     )))

;;	 (format nil "~A~A" "C:/Program Files/Jamming/Jamming.exe -f -w " word)
;;	 (concat "C:/Program Files/Jamming/Jamming.exe -p -f -n " name)
;;	 (concat "C:/Program Files/Jamming/Jamming.exe -f -w " word)



;;;;;;;;;;;;;;;;̎擾
(defun get-current-word-or-selection ()
  (interactive)
  (let (word)
    (if (pre-selection-p)
	(let ((start (selection-point))
	      (end (selection-mark)))
	  (setq word (buffer-substring start end)))
      (save-excursion ;;J[\ʒuACT[V|Cg߂Ă
	(setq word
	      (buffer-substring
	       ;(progn (goto-word-head) (point))
	       ;(progn (backward-word) (point))
	       ;(point) ;;肭Ȃ̂ŃJ[\ʒuɓ
	       (progn (backward-word-stop) (point)) ;;P̓ňړ~߂
	       (progn (forward-word) (point)))
	      )
	))
    word))

;;;;;;;;;;;;;;;;P̓ňړ~߂
;(char= (preceding-char) #\LFD) ;#\SPC ;#\^ ;#\TAB
;(char= (following-char) (character "^")
;(setq pchar (preceding-char))
;(when (/= 0 (point))
;(forward-char 1)
;(looking-back " ")

;;(forward-word -1) LȂǂ͂Ƃ΂Ă܂̂
;;(unless (looking-at "\\<");;P̍sɃ}b`͉p݂̂Ȃ̂
;;ƃJ^Ji͒PAЂ炪Ȃ͂Ƃ΂݂Ȃ̂
;;ÕL󔒂Ȃǂ͎̎~܂悤ɂ
;;ł̃L󔒂Ȃǂ͈̎ړ

;;IȂ͎̂̂ĂāAmɎ~܂`ŌŒ
;;p̒P̓Ȃ~߂
;;O󔒂ŁA낪󔒂łȂȂ~߂
(defun backward-word-stop ()
  (interactive)
  (when (forward-char -1)
    (setq bchar (looking-at "\\([ \t@\n]\\)"))
    (forward-char 1)
    (setq fchar (looking-at "\\([ \t@\n]\\)"))
    (unless (or (looking-at "\\<")
		(and bchar
		     (null fchar)))
      (forward-word -1))
    )
  )

#|
;;;;;;;;;;;;;;;;
;; P̐擪
(defun goto-word-head ()
  (cond ((looking-at " ")
	 (backward-word 1))
	((looking-at "\\<"))
	(t
	 (backward-word 1))))
|#

;;;;;;;;;;;;;;;; }j[U@insert menu tools c[
;;c[̓ɑ} menu item 0
(defvar *Jamming-popup-menu* nil)

(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (init-Jamming-menu)
	      (when (setq menu (get-menu *app-menu* 'ed::tools))
		(insert-popup-menu menu 0 *Jamming-popup-menu* "Jamming(&Q)")
		(insert-menu-separator menu 1 'tool-Jamming-sep)
		)
	      )
	  )

(defun init-Jamming-menu ()
  (or *Jamming-popup-menu*
      (setq *Jamming-popup-menu* (create-popup-menu)))

  (setq *Jamming-popup-menu*
	(define-popup-menu
	  (:item nil "JammingN(&P)"
	   'Jamming-app)
	  :sep
	  (:item nil "ׂĂ̎_ʏ팟(&A)"
	   'Jamming-search-normal-all-selection)
	  (:item nil "ׂĂ̎_Sv(&C)"
	   'Jamming-search-complete-all-selection)
	  (:item nil "ׂĂ̎_[hŌ(&E)"
	   'Jamming-search-western-all-selection)
	  :sep
	  (:item nil "ʏ_ʏ팟(&S)"
	   'Jamming-search-normal-selection)
	  (:item nil "ʏ_Sv(&C)"
	   'Jamming-search-complete-selection)
	  (:item nil "ʏ_[hŌ(&E)"
	   'Jamming-search-western-selection)
	  :sep
	  (:item nil "(&J)"
	   'Jamming-search-kanjigen-selection)
	  (:item nil "L@l(&K)"
	   'Jamming-search-Koujien-selection)
	  (:item nil "Oȓu厫сv(&D)"
	   'Jamming-search-Daijirin-selection)
	  (:item nil "Ё@VpaEapT(&C)"
	   'Jamming-search-Chujiten-selection)
	  (:item nil "ʐMp̊bm(&W)"
	   'Jamming-search-pc_wdic-selection)
	  )
	)
  )

;;;;;;;;;;;;;;;; }j[@ENbN@obt@[
(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (init-Jamming-menu)
	      (when *app-popup-menu*
		(setq ip -1)
		(while (get-menu *app-popup-menu* (incf ip) t))
		(insert-menu-separator *app-popup-menu* ip 'Jamming-sep)
		(insert-popup-menu *app-popup-menu* (incf ip) *Jamming-popup-menu* "Jamming(&Q)")
		)
	      )
	  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#|
;;;Ăяo
(defun launch-application (app)
  (interactive "e% " :history0 'execute)
  (call-process app :no-std-handles t :show :show
		:exec-directory *launch-app-directory*))
|#

;;;Jamming̃pX
;"C:/Program Files/Jamming/Jamming.exe"

;;;
;word
